macro
: 1+ $40 1, ;              : 1- $48 1, ;
: swap $0687 2, ;          : drop $ad 1, ; 
: nip $04c683 3, ;         : false $f9 1, ;
: true $f8 1, ;

forth
: swap swap ;              : drop drop ;
: nip nip ;                : dup [ $fc4689 3, $fc768d 3, ] ;
: and [ $0623 2, ] nip ;   : or [ $060b 2, ] nip ;
: xor [ $0633 2, ] nip ;   : not -1 xor ;          

: @ [ $008b 2, ] ;         : ! [ $89adc289 , $ad02 2, ] ;
: c@ @ $ff and ;           : c! [ $adc289 3, $ad0288 3, ] ;

: hex 16 base ! ;          : decimal 10 base ! ;
: binary 2 base ! ;        : octal 8 base ! ;

: + [ $0603 2, ] nip ;     : * [ $26f7 2, ] nip ;
: - [ $ad0629 3, ] ;       : negate -1 * ;
: /mod [ $c389 2, $99ad 2, $fbf7 2, ] dup [ $d089 2, ] ;
: / /mod drop ;            : mod /mod nip ;
: 1+ 1+ ;                  : 1- 1- ;

: wsparse 32 parse ;       : lnparse 10 parse ;
: ( ') parse drop drop ;   : | lnparse drop drop ;

: >> [ $c189 2, $d3ad 2, $e8 1, ] ;
: << [ $c189 2, $d3ad 2, $e0 1, ] ;

: here h0 @ ;

macro
: f: wsparse find compile ;
: m: wsparse mfind compile ;
: ['] wsparse find m: literal ;

: : wsparse entry ;        : ( f: ( ;

: >r $ad50 2, ;            : r> $04ee83 3, $0689 2, $58 1, ;
: r m: r> $50 1, ;

: prior last @ >r last @ @ last ! 32 parse find compile r> last ! ;

: repeat here ;            : again compile ;
: next m: r> : until $48 1, $c009 2, $850f 2, here - 4 - , $ad 1, ;
: for here m: >r ;

: (if) $063b 2, $adad 2, 1, here 0 1, ;
: <>if $74 m: (if) ;       : =if  $75 m: (if) ;
: <if  $7e m: (if) ;       : >if  $7d m: (if) ;
: ?if  $72 1, here 0 1, ;
: then dup here swap - 1- swap c! $90 1, ;

forth
: allot here + h0 ! ;      : cells 4 * ;         : cell+ 4 + ;

: later r> r> swap >r >r ; : exit, $c3 1, ;
: create: wsparse entry ;  : variable 0 : variable: create , ;
: rot >r swap r> swap ;    : -rot rot rot ;
: tuck swap                : over swap dup -rot ;
: 2dup over over ;         : 2drop drop drop ;
: ' wsparse find ;         : alias create: last @ cell+ ! ;
: execute >r ;             : 0; dup 0 =if r> 2drop ;; then ;
: literal, m: literal ;

create list 5 cells allot
: loc: list @ 1+ cells list + list @ 1+ list ! last @ swap ! ;
: ;loc list @ cells list + list @ 1- list ! @ last ! ;

: fill swap repeat >r swap 2dup c! 1+ swap r> until 2drop ;
: move for swap 2dup c@ swap c! 1+ swap 1+ next 2drop ;
: pad here 1024 + ;        : >pad dup >r pad swap move pad r> ;

: " '" parse dup 0 <>if >pad then ;          : ." " type ;
loc:
  : string, here 20 + over swap literal, literal, ;
  here ] string, $eb 1, dup 1, for dup c@ 1, 1+ next drop $90 1, ;
;loc alias $,

loc:
  variable size            : update 1+ size @ + size ! ;
  : place here swap move here ;
  : make dup -rot place swap dup allot 0 1, update ;
  : free size @ negate allot 0 size ! ;
  here ] make later free ;
;loc alias zt

macro
: s" " $, ;                : ." m: s" ['] type compile ;

forth
: cr 10 emit ;             : space 32 emit ;
: . dup 0 <if '- emit negate then : u. # space ;

: words last repeat @ 0; dup 9 + dup 1- c@ type space again ;
reset

here ] ." Error: Word Not Found: " type cr ; word? !
: ok interpret ok ;  ' ok
." RetroForth 8.0  ::  Visit http://www.retroforth.org for updates" cr cr
: clear scr_size repeat space until home ;
: (fg) $fffff0ff swap 8 << setAttr ;
: (bg) $ffff0fff swap 12 << setAttr ;

: black 0 (fg) ;   : blue 1 (fg) ;   : green 2 (fg) ;
: cyan 3 (fg) ;    : red 4 (fg) ;    : magenta 5 (fg) ;
: brown 6 (fg) ;   : white 7 (fg) ;  : yellow 14 (fg) ;
: brightWhite 15 (fg) ;

: onBlack 0 (bg) ;   : onBlue 1 (bg) ;   : onGreen 2 (bg) ;
: onCyan 3 (bg) ;    : onRed 4 (bg) ;    : onMagenta 5 (bg) ;
: onBrown 6 (bg) ;   : onWhite 7 (bg) ;  : onYellow 14 (bg) ;
: onBrightWhite 15 (bg) ;

: normal white onBlack clear ;

forth
variable blk    64 variable: #blks
: (block) blk @ : block 512 * there + ;
: (line) 64 * (block) + ;

: p blk @ 1- blk ! ;       : n blk @ 1+ blk ! ;
: d (line) 64 32 fill ;    : x (block) 512 32 fill ;
: eb (block) 1024 eval ;   : el (line) 64 eval ;
: e 0 el 1 el 2 el 3 el 4 el 5 el 6 el 7 el ;
: ia (line) + >r 10 parse r> swap move ;
: i 0 swap ia ;            : s blk ! ;
: \ 1 s e ;                : \f there #blks @ 512 * eval ; 

: blocks #blks ! ;          : new 0 block #blks @ 512 * 32 fill 0 s ;
new
loc:
 : row green dup 64 type 64 + cr ;
 : .rows 8 repeat dup 8 swap - red . >r row r> until ; 
 : .block ." Block: " blk @ . ;
 : x--- ." +---:---+---:---" ; 
 : --- white space space x--- x--- x--- x--- cr ;
 : v --- blk @ block .rows drop --- ;
 : .stack ."  Stack: "
 : .s 10 repeat dup [ $86048b 3, ] . until cr ;
 : status green .block .stack ;
 ' status ' .s ' v
;loc alias v alias .s alias status

loc:
 : cl home 11 for cr next 80 for space next home ;
 variable edit?
 : exit 1 edit? ! ;
 : exit! 0 edit? ! ;
 : edit onBlack clear 
 : .1 edit? @ 1 =if exit! ;; then cl v status white interpret .1 ;
' exit  ' edit
;loc  alias edit  alias exit
 forth
: p1@ [ $c289 2, $ec 1, $c0b60f 3, ] ;
: p1! [ $068bc289 , $04468bee , $08768d 3, ] ;
: p2@ [ $ed66c289 , $c0b70f 3, ] ;
: p2! [ $068bc289 , $468bef66 , $08768d04 , ] ;
1 variable: blk0
loc:
 : status $1f7 p1@ dup 1 and 1 =if ." IDE0 ERROR" cr then ; 
 : busy status $80 and 0; drop busy ;
 : ready status 8 and 0 =if ready ;; then ;
 : #s 1 $1f2 p1! ;
 : sn dup $1f3 p1! ;
 : cl dup 8 >> $1f4 p1! ;
 : ch dup 16 >> $1f5 p1! ;
 : hd dup 24 >> $e0 or $1f6 p1! ;
 : lba busy hd cl ch sn #s drop ;
 : write lba $30 $1f7 p1! ;
 : read lba $20 $1f7 p1! ;
 : 16bits over @ $1f0 p2! ;
 : words 0; 16bits 1- swap 2 + swap words ;
 : data ready 256 words drop ;
 : sector dup blk0 @ + write block data ;
 : sectors 0; 1- dup sector sectors ;
 : w #blks @ sectors ;
 : w! [ $068bc289 , $8b028966 , $768d0446 , $08 1, ] ;
 : 16bits ready over $1f0 p2@ swap w! ;
 : words 0; 16bits 1- swap 2 + swap words ;
 : data 256 words drop ;
 : sector dup blk0 @ + read block data .s cr ;
 : sectors 0; 1- dup sector sectors ;
 : r #blks @ sectors ;
 ' w ' r
;loc alias r alias w

hex forth

( These are kept deliberately long to avoid  )
( accidental, unintentional use.  Since they )
( deal with the L4 kernel interface, they    )
( are kind of too important to use without   )
( caution.                                   )

( -- kernelID kernelAPIFlags kernelAPIVersion KIP )
( NOTE: Destroys EBX!  Otherwise, it's safe to call at any time )
: L4$KernelInterface dup [ 8b90f056 , 7389241c , f85389fc , 8df44b89 , c483f473 , 04 1, ] ;

L4$KernelInterface variable: L4$KIP
                   variable: L4$KernelAPIVersion
                   variable: L4$KernelAPIFlags
                   variable: L4$KernelID

decimal

: t0 ." Undefined" ;
: t1 ." Conventional memory" ;
: t2 ." Reserved for the L4 microkernel" ;
: t3 ." Dedicated Memory" ;
: t4 ." Shared Memory" ;
: t? ." not specified by L4Ka" ;
: tE ." Boot-loader defined" ;
: tF ." Architecture specific" ;

create type-table
' t0 , ' t1 , ' t2 , ' t3 ,
' t4 , ' t? , ' t? , ' t? ,
' t? , ' t? , ' t? , ' t? ,
' t? , ' t? , ' tE , ' tF ,

: hextab s" 0123456789ABCDEF" drop ;
: nybble 28 >> 15 and hextab + c@ emit ;
: rotate dup 28 >> 15 and swap 4 << or ;
: ` dup nybble rotate ;
: .type dup @ 15 and cells type-table + @ execute ;
: .h ` ` ` ` ` ` ` ` drop space ;
: .high dup 4 + @ $FFFFFC00 and $3FF or .h ;
: .low dup @ $FFFFFC00 and .h ;
: .v dup @ $200 and 0 =if ." P " ;; then ." V " ;
: .region .low .high .v .type cr 8 + ;
: meminfo L4$KIP @ $54 + @ ;
: 1stRegion meminfo 16 >> L4$KIP @ + ;
: #regions meminfo $FFFF and dup . ." regions total" cr ;
: .memregions 1stRegion #regions for .region next drop ;
